;;; Programm zum wiederholten Einfgen von Blcken
;;; 17.01.2001 von Marc Scherer
;;; Funktionsaufrufe: EP und EPD
;;; (EinfgungPunkt und EinfgungPunktDrehwinkel)
;;;
;;; Version 1.1
;;;     Das Problem aus Version 1.0 mit dem Aufruf vom Attributdialogfeld
;;;     ist gelst.
;;;     Die Lsung wurde mir freundlicherweise von Herrn Gnther Bittner zugemailt.
;;;     Gnther hat's unter R14 getestet - und luft...
;;;     Ich hab's unter 2000i getestet und luft...
;;;     Vielen Dank Gnther Bittner.
;;;     Weitere nderungen: Einen saublden Bug entfernt, der es unmglich machte
;;;     Blcke einzufgen, die NICHT im ACAD-Suchpfad zu finden sind...
;;;     Sorry, but Shit happens...

;;; Zum Aufruf des Programms empfiehlt es sich, dieses in den
;;; AutoCAD Suchpfad zu kopieren und ein Menmakro oder Toolbarmakro zu
;;; definieren.
;;; Bei mir wrde folgendes als Makro stehen:
;;;
;;;  ^c^c(if (null c:ep)(load "ep-epd.lsp"))(princ);ep;
;;; und
;;;  ^c^c(if (null c:epd)(load "ep-epd.lsp"))(princ);epd;

;;; Programm ist lauffhig unter AutoCAD R14 und R15 (2000)

;;; Zum Anpassen des Vorgabepfades fr das Dialogfeld sollte man in
;;; der Zeile:
;;;
;;; (setq	DEF-PATH "c:\\Temp\\" ;_ Vorgabe Verzeichnis fr Dialogfeld
;;;
;;; die Pfadangabe abndern. Dabei nicht den Doppelbackslash vergessen!
;;; 1 Backslash im Pfad = 2 Backslashes im AutoCAD

;;; fr UNC Pfade also "\\\\Servername\\Verzeichnisname\\"



;;; Programmaufruf fr:
;;; EP = Einfgung Punkt
;;; bergibt der Hauptfunktion den Parameter nil
;;; d.h. Drehwinkel NICHT abfragen
(defun C:EP (/)
  (INS-SERT NIL)
  (princ)
) ;_ end defun

;;; Programmaufruf fr:
;;; EPD = Einfgung Punkt Drehwinkel
;;; bergibt der Hauptfunktion den Parameter T
;;; d.h. Drehwinkel abfragen
(defun C:EPD (/)
  (INS-SERT t)
  (princ)
) ;_ end defun

;;; Hauptfunktion
;;; eigentliche Funktion zum Einfgen der Blcke
;;; erwartet einen Startparameter:
;;; T = mit Drehwinkel
;;; nil = ohne Drehwinkel
(defun INS-SERT	(FLAG	     /		 ALT_ATTDIA  ALT_ATTREQ
		 ALT_CMD     ALT_DIA	 ALT_ERROR   CHK
		 DAT	     DATA	 DEF-PATH    ENT
		 ENT-LST     INS-COMMAND INS-EXIST   INS-NAME
		 INS_ERROR   PKT	 X-WRT-ALT   X-WRT-NEU
		 ZHEIGHT     ZKORD
		)
  
  ;;; Beginne internen Errorhandler...
  (defun INS_ERROR (MSG)
    (princ
      (strcat "\nFehler, Acad meldet: \""
	      MSG
	      "\" als Ursache!"
      ) ;_ end strcat
    ) ;_ end princ
    (setvar "cmdecho" ALT_CMD)
    (setvar "cmddia" ALT_DIA)
    (setvar "attreq" ALT_ATTREQ)
    (setvar "attdia" ALT_ATTDIA)
    (setq *ERROR* ALT_ERROR)
    (princ)
  ) ;_ end defun
  ;;; beende internen Errorhandler

  ;;; Alte Sysvars sichern....
  (setq	ALT_ERROR  *ERROR*
	*ERROR*	   INS_ERROR
	ALT_CMD	   (getvar "cmdecho")
	ALT_DIA	   (getvar "cmddia")
	ALT_ATTREQ (getvar "attreq")
	ALT_ATTDIA (getvar "attdia")
  ) ;_ end setq

  ;;; Sysvars fr Pgm setzen
  (setvar "cmdecho" 0)
  (setvar "cmddia" 0)
  (setvar "attreq" 0)
  (setvar "attdia" 0)

  ;;; Variablen setzen...
  (setq	DEF-PATH "c:\\Temp\\" ;_ Vorgabe Verzeichnis fr Dialogfeld
	DAT	 (getfiled "Whle einen Block zum Einfgen aus..."
			   DEF-PATH
			   "dwg"
			   0
		 ) ;_ end getfiled
	ZHEIGHT	 50 ;_ Zoomhhe
  ) ;_ end setq
  (if (= DAT NIL) ;_ Wenn keine Datei gewhlt wurde...
    (princ "\nKeine Datei gewhlt. Programmende!") ;;; ... Dann nix wie raus aus'm Pgm
    (progn ;_ ansonsten...

      ;;; AutoCAD 14 oder 15?
      (cond
	((wcmatch (getvar "acadver") "15*")
	 (setq INS-NAME (strcase (vl-filename-base DAT))) ;_ Nur Dateiname R15
	)
	((wcmatch (getvar "acadver") "14*")
	 (setq INS-NAME (DATSTRIP DAT)) ;_ Nur Dateiname R14
	)
	(T (exit)) ;_Wenn weder 14 noch 15 dann EXIT, unelegant aber effektiv ;-)
      ) ;_ end cond
      ;;; 14 oder 15 Ende

      
      (setq INS-EXIST (tblsearch "BLOCK" INS-NAME)) ;_ ist der Block intern schon vorhanden?
      (if INS-EXIST ;_ Wenn der Block intern existiert...
	(setq DAT INS-NAME) ;_ nimm nur den Blocknamen
      ) ;_ end if
      (if FLAG ;_ Wenn der Aufruf von EPD kommt...
	(setq INS-COMMAND ;_ Ist folgende Zeile der Kommandostring
	       '(command "_.insert" DAT PKT "1" "1" PAUSE)
	) ;_ Kommando mit Drehung
	;;; ...ansonsten diese Zeile
	(setq INS-COMMAND '(command "_.insert" DAT PKT "1" "1" "")) ;_ Kommando ohne Drehung
      ) ;_ end if
      (setq ENT-LST '()) ;_ leere Liste erzeugen
      (while
	(setq
	  PKT (getpoint "\nPunkt fr Einfgung (Rechtsklick=Ende): ")
	) ;_ solange ein Punkt geklickt wird...
	 (eval INS-COMMAND) ;_ fhre den Kommandostring aus
	 (setq ENT     (entlast)
	       ENT-LST (cons ENT ENT-LST)
	 ) ;_ end setq
      ) ;_ end while
      (if (> (length ENT-LST) 0) ;_ Wenn Objektnamen in der Liste sind...
	(progn
	  (setq CHK (assoc 66 (entget (nth 0 ENT-LST)))) ;_ hat der Block Attribute?
	  (cond
	    ((= CHK NIL)
	     (princ "\nEingefgter Block hat keine Attribute...")
	    )
	    (t
	     (if (= (cdr CHK) 0)
	       (princ
		 "\nEingefgter Block hat keine editierbaren Attribute..."
	       ) ;_ end princ
	       (progn
		 (princ
		   "\nEingefgter Block hat editierbare Attribute..."
		 ) ;_ end princ
		 (foreach ELEM (reverse ENT-LST) ;_ drehe die Liste ENT-LST um, damit der erste
		                                 ;_ gezeichnete Block auch als erster von "_.ddatte" bearbeitet wird.
		   (setq DATA	   (entget ELEM)
			 ELEM	   (cdr (assoc -1 DATA)) ;_ benutze die Funktion (cdr), um auf das zweite Element
			                                 ;_ von ELEM zuzugreifen, sonst kommt "_.ddatte" nicht klar..
			 ZKORD	   (cdr (assoc 10 DATA))
			 X-WRT-ALT (car ZKORD)
			 X-WRT-NEU (- X-WRT-ALT (/ ZHEIGHT 2))
			 ZKORD	   (subst X-WRT-NEU X-WRT-ALT ZKORD)
		   ) ;_ end setq

		   (command "_.zoom" "_c" ZKORD ZHEIGHT)
		   (command "_.ddatte" ELEM) ;_ ersetze "_.attedit" durch "_.ddatte" (mit "_.attedit" kam ich nicht zum Ziel).
		 ) ;_ end foreach
	       ) ;_ end progn
	     ) ;_ end if
	    )
	  ) ;_ end cond
	) ;_ end progn
      ) ;_ end if
    ) ;_ end progn
  ) ;_ end if

  ;;; alte Sysvars herstellen...
  (setvar "cmdecho" ALT_CMD)
  (setvar "cmddia" ALT_DIA)
  (setvar "attreq" ALT_ATTREQ)
  (setvar "attdia" ALT_ATTDIA)
  (setq *ERROR* ALT_ERROR)
  (princ)
) ;_ end defun



;;; Funktion lst den Dateinamen aus einer vollen Pfadangabe
;;; notwendig fr R14 Lisp
;;; VisualLisp hat dafr 'ne interne Funktion (wie GEIL!!)
(defun DATSTRIP
       (FILENAME / DIFF DIRLENGTH FILENAME2 LEN1 LEN2 TESTSTR)
  (setq	TESTSTR	  NIL ;_ Teststring auf nix setzen
	DIRLENGTH (strlen FILENAME) ;_ Lnge der gesamten Pfadangabe
	LEN1	  (- DIRLENGTH 4) ;_ Lnge ohne Dateierweiterung .dwg
	FILENAME  (substr FILENAME 1 LEN1) ;_ nur der Pfad, ohne Erweiterung
	FILENAME2 FILENAME ;_ setz die Variablen gleich...
	LEN2	  (strlen FILENAME2) ;_ Lnge von Filename2
  ) ;_ end setq
  (while (/= TESTSTR "\\") ;_ solange kein Backslash kommt...
    (setq TESTSTR   (substr FILENAME2 LEN2 1) ;_ Hol dir das letzte Zeichen des Strings
	  FILENAME2 (substr FILENAME2 1 LEN2) ;_ Neuer Filename2
	  LEN2	    (1- LEN2) ;_ 1 Zeichen abziehen
    ) ;_ end setq
  ) ;_ end while
  (setq	DIFF	 (- (strlen FILENAME) (strlen FILENAME2)) ;_ Anzahl Zeichen fr substr
	LEN1	 (1+ (strlen FILENAME2)) ;_ Startposition fr substr
	FILENAME (substr FILENAME LEN1 DIFF)
  ) ;_ end setq
) ;_ end defun


(princ
  "\n\(c\)2001 by Marc Scherer. Use at your own Risk!\nMehrfaches Einfgen von Blcken. Kommandos: EP oder EPD"
) ;_ end princ
(princ)
